{{  SerialFromEepromDemo150226a

  PASM section of serial driver will be retrieved 
  from EEPROM.

  Program "LoadToEepromSerial_150226c.spin" was
  used to store the PASM to EEPROM.
  
  Program to test communication objects.
  The program both sends and receives information.

  See following forum thread for more information:

  http://forums.parallax.com/showthread.php/160155

  The port "LARGE_BALANCE_COM" is presently not used.
  I wanted to test buffers with zero size.
  
}}
{
  17b is garbled
  18f PASM section moved to parent.
  18f Works with 18s child.
  18g Tried to change longs to reserved variables. It didn't work.
  The output was gibberish.
  26a Add PASM delayed start.
  26a Still works.
  26b Still works.
  26d Does not work with new code.
  Rename "SerialCogjectDemo150226e" to "SerialFromEepromDemo150226a".
  26a Add EEPROM support.
  
}
CON

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  '' Pin asignments
  LARGE_BALANCE_RX = 3        
  LARGE_BALANCE_TX = 2       
  ANALYTICAL_BALANCE_RX = 1   
  ANALYTICAL_BALANCE_TX = 0  
  SPECTROMETER_RX = 5
  SPECTROMETER_TX = 4
  
  DEBUG_BAUD = 57600 
  ANALYTICAL_BAUD = 57600 
  LARGE_BALANCE_BAUD = 57600 
  SPECTROMETER_BAUD = 57600 
 

  ' Com enumeration
  #0, DEBUG_COM, ANALYTICAL_BALANCE_COM, LARGE_BALANCE_COM, SPECTROMETER_COM
   
CON

' The following constants declare the sizes of the rx and tx buffers.
' Enter in the needed size in bytes for each rx and tx buffer
' These values can be any size within available memory. They do not have to be a power of two.
' Unused buffers can be reduced to 0 bytes.
  RX_SIZE0 = 64  ' receive buffer allocations
  RX_SIZE1 = 60
  RX_SIZE2 = 0 '60
  RX_SIZE3 = 60

  TX_SIZE0 = 64  ' transmit buffer allocations
  TX_SIZE1 = 60
  TX_SIZE2 = 0 '60
  TX_SIZE3 = 60   

  SERIAL_EEPROM_START = $8000
  SERIAL_EEPROM_SIZE = $710
  
VAR

  byte buffer[SERIAL_EEPROM_SIZE]
  
OBJ

  Com : "SerialNoPasm150226e"
  Format : "StrFmt"
  Ee : "dwd_PropellerEeprom"
  
PUB Main : loopCount | localIndex, localCharacter

  waitcnt(clkfreq * 2 + cnt) 

  Ee.ToRam(@buffer, @buffer + SERIAL_EEPROM_SIZE - 1, SERIAL_EEPROM_START)
  
  Com.Init(@buffer, @buffer) ' location of PASM code and location of rx and tx buffers
     
  Com.AddPort(DEBUG_COM, 31, 30, -1, -1, 0, 0, DEBUG_BAUD, RX_SIZE0, TX_SIZE0)
  
  Com.AddPort(ANALYTICAL_BALANCE_COM, ANALYTICAL_BALANCE_RX, ANALYTICAL_BALANCE_TX, {
  } -1, -1, 0, 0, ANALYTICAL_BAUD, RX_SIZE1, TX_SIZE1)
  {
  Com.AddPort(LARGE_BALANCE_COM, LARGE_BALANCE_RX, LARGE_BALANCE_TX, {
  } -1, -1, 0, 0, LARGE_BALANCE_BAUD, RX_SIZE2, TX_SIZE2)
  }
  Com.AddPort(SPECTROMETER_COM, SPECTROMETER_RX, SPECTROMETER_TX, {
  } -1, -1, 0, 0, SPECTROMETER_BAUD, RX_SIZE3, TX_SIZE3)
  
  Com.Start
  
  localIndex := 0
  
  repeat
    
    loopCount++
    if loopCount // 4 == 0
      Com.str(DEBUG_COM, string(13, "tx from "))
      Com.str(DEBUG_COM, FindString(@portsAsText, ANALYTICAL_BALANCE_COM))
      repeat localIndex from 0 to 0 '9        
        Com.str(ANALYTICAL_BALANCE_COM, FindString(@analyticalBalanceOutput1, localIndex))
    {if loopCount // 4 == 1
      Com.str(DEBUG_COM, string(13, "tx from "))
      Com.str(DEBUG_COM, FindString(@portsAsText, LARGE_BALANCE_COM))
      repeat localIndex from 0 to 0 '9
        Com.str(LARGE_BALANCE_COM, FindString(@largeBalanceOutput1, localIndex))  }
    if loopCount // 4 == 2
      Com.str(DEBUG_COM, string(13, "tx from "))
      Com.str(DEBUG_COM, FindString(@portsAsText, SPECTROMETER_COM))
      repeat localIndex from 0 to 0 '9
        Com.str(SPECTROMETER_COM, FindString(@spectrometerOutput1, localIndex)) 
    repeat localIndex from DEBUG_COM to SPECTROMETER_COM
      localCharacter := Com.rxcheck(localIndex)
      if localCharacter => 0 
        Com.str(DEBUG_COM, string(13, "rx("))
        Com.str(DEBUG_COM, FindString(@portsAsText, localIndex))
        'Dec(DEBUG_COM, localIndex)
        Com.str(DEBUG_COM, string(")= ", 13))
       
        repeat while localCharacter <> -1
          if localCharacter => 0
            SafeTx(DEBUG_COM, localCharacter) 
          localCharacter := Com.rxcheck(localIndex)
          
    waitcnt(clkfreq / 3 + cnt)
      
PUB SafeTx(port, localCharacter)

  if (localCharacter > 31 and localCharacter < 127) or localCharacter == 13
    Com.tx(port, localCharacter)    
  else
    Com.tx(port, 60)
    Com.tx(port, 36) 
    Hex(port, localCharacter, 2)
    Com.tx(port,  62)

PUB Dec(port, value) | localBuffer[3]

  result := Format.Dec(@localBuffer, value)
  byte[result] := 0 ' probably not needed
  Com.Str(port, @localBuffer)

PUB DecPoint(port, value, length, places) | localBuffer[3]
'' Lock should be set prior to calling this method.

  result := Format.Fdec(@localBuffer, value, length, places)
  byte[result] := 0 ' probably not needed
  Com.Str(port, @localBuffer)
  
PUB Hex(port, value, digits) | localBuffer[3]  

  result := Format.Hex(@localBuffer, value, digits)
  byte[result] := 0 ' probably not needed
  Com.Str(port, @localBuffer)
  
PUB FindString(firstStr, stringIndex)     
'' Finds start address of one string in a list
'' of string. "firstStr" is the address of 
'' string #0 in the list. "stringIndex"
'' indicates which of the strings in the list
'' the method is to find.

  result := firstStr 
  repeat while stringIndex    
    repeat while byte[result++]  
    stringIndex--

DAT                                  '         1         2         3         4         5
                                     '12345678901234567890123456789012345678901234567890123456789
analyticalBalanceOutput1        byte "Analytical, one, two, three, four, five, six", 13, 0 {45}
analyticalBalanceOutput2        byte "Analytical, seven, eight, nine, ten, eleven, twelve", 13, 0 {52.97}
analyticalBalanceOutput3        byte "Analytical, thirteen, fourteen, fifteen, sixteen", 13, 0 {49,146}
analyticalBalanceOutput4        byte "Analytical, seventeen, eighteen, nineteen, twenty", 13, 0 {50,196}
analyticalBalanceOutput5        byte "Analytical, twenty one, twenty two, twenty three", 13, 0 {49,245}
                                     '         1         2         3         4         5 
                                     '12345678901234567890123456789012345678901234567890123456789 
analyticalBalanceOutput6        byte "Analytical, twenty four, twenty five, twenty six", 13, 0 {49,294}
analyticalBalanceOutput7        byte "Analytical, twenty seven, twenty eight, twenty nine", 13, 0 {52,346}
analyticalBalanceOutput8        byte "Analytical, thirty, thirty one, thirty two, thirty three", 13, 0 {57,403}
analyticalBalanceOutput9        byte "Analytical, thirty four, thirty five, thirty six", 13, 0 {49,452}
analyticalBalanceOutput10       byte "Analytical, thirty seven, thirty eight, thirty nine", 13, 0 {52,504}
                                     '         1         2         3         4         5 
                                     '12345678901234567890123456789012345678901234567890123456789 
largeBalanceOutput1             byte "Large     , one, two, three, four, five, six", 13, 0 {45}
largeBalanceOutput2             byte "Large     , seven, eight, nine, ten, eleven, twelve", 13, 0 {52.97}
largeBalanceOutput3             byte "Large     , thirteen, fourteen, fifteen, sixteen", 13, 0 {49,146}
largeBalanceOutput4             byte "Large     , seventeen, eighteen, nineteen, twenty", 13, 0 {50,196}
largeBalanceOutput5             byte "Large     , twenty one, twenty two, twenty three", 13, 0 {49,245}
                                     '         1         2         3         4         5 
                                     '12345678901234567890123456789012345678901234567890123456789 
largeBalanceOutput6             byte "Large     , twenty four, twenty five, twenty six", 13, 0 {49,294}
largeBalanceOutput7             byte "Large     , twenty seven, twenty eight, twenty nine", 13, 0 {52,346}
largeBalanceOutput8             byte "Large     , thirty, thirty one, thirty two, thirty three", 13, 0 {57,403}
largeBalanceOutput9             byte "Large     , thirty four, thirty five, thirty six", 13, 0 {49,452}
largeBalanceOutput10            byte "Large     , thirty seven, thirty eight, thirty nine", 13, 0 {52,504}
                                     '         1         2         3         4         5 
                                     '12345678901234567890123456789012345678901234567890123456789                                                                                                   
spectrometerOutput1             byte "Spectro   , one, two, three, four, five, six", 13, 0 {45}
spectrometerOutput2             byte "Spectro   , seven, eight, nine, ten, eleven, twelve", 13, 0 {52.97}
spectrometerOutput3             byte "Spectro   , thirteen, fourteen, fifteen, sixteen", 13, 0 {49,146}
spectrometerOutput4             byte "Spectro   , seventeen, eighteen, nineteen, twenty", 13, 0 {50,196}
spectrometerOutput5             byte "Spectro   , twenty one, twenty two, twenty three", 13, 0 {49,245}
                                     '         1         2         3         4         5 
                                     '12345678901234567890123456789012345678901234567890123456789 
spectrometerOutput6             byte "Spectro   , twenty four, twenty five, twenty six", 13, 0 {49,294}
spectrometerOutput7             byte "Spectro   , twenty seven, twenty eight, twenty nine", 13, 0 {52,346}
spectrometerOutput8             byte "Spectro   , thirty, thirty one, thirty two, thirty three", 13, 0 {57,403}
spectrometerOutput9             byte "Spectro   , thirty four, thirty five, thirty six", 13, 0 {49,452}
spectrometerOutput10            byte "Spectro   , thirty seven, thirty eight, thirty nine", 13, 0 {52,504}
                                     '         1         2         3         4         5 
                                     '12345678901234567890123456789012345678901234567890123456789
DAT portsAsText

                                byte "DEBUG_COM", 0
                                byte "ANALYTICAL_BALANCE_COM", 0
                                byte "LARGE_BALANCE_COM", 0
                                byte "SPECTROMETER_COM", 0
                                                                           